%union {
   string* str;
   unsigned int uint;
}

%token <str> TOK_HEADER
%token <str> TOK_STRING
%token <uint> TOK_HEXNUMBER
%token <str> TOK_USEDFUNCTIONS
%token <str> TOK_OPEN
%token <str> TOK_CLOSE

%type <str> def header usedfunctions more_functions more_implementations more_interfaces

%start def

%%

def: header usedfunctions
     ;

header: TOK_HEADER TOK_OPEN TOK_STRING TOK_HEXNUMBER TOK_CLOSE
        { this->comment = $3;
          this->stackSize = $4;
        }
     ;

usedfunctions: /* empty */  { }
               | TOK_USEDFUNCTIONS TOK_OPEN TOK_STRING TOK_HEXNUMBER TOK_OPEN TOK_STRING TOK_OPEN TOK_STRING TOK_HEXNUMBER
               { if (!$3)
                     throw ESyntaxeError(string("Used interface must have a name."));
                 if ($3->length() > 31)
                     throw ESyntaxeError(string("Used interface name cannot be bigger than 31 chars."));
                 this->newInt = new Interface;
                 this->newInt->name = $3;
                 this->newInt->prop = $4;
                 this->interfaces.push_back(this->newInt);
                 if ($6 && $6->length() > 31)
                     throw ESyntaxeError(string("Used implementation name cannot be bigger than 31 chars."));
                 this->newImp = new Implementation;
                 this->newImp->name = $6;
                 this->newInt->imps.push_back(this->newImp);
                 if (!$8)
                     throw ESyntaxeError(string("Used function must have a name."));
                 UsedFunction *newUF = new UsedFunction;
                 newUF->name = $8;
                 newUF->number = $9;
                 this->newImp->functions.push_back(newUF);
               }
               more_functions TOK_CLOSE more_implementations TOK_CLOSE more_interfaces TOK_CLOSE
     ;

more_functions: /* empty */ { }
                    | TOK_STRING TOK_HEXNUMBER
                    { if (!$1)
                         throw ESyntaxeError(string("Used function must have a name."));
                      UsedFunction *newUF = new UsedFunction;
                      newUF->name = $1;
                      newUF->number = $2;
                      this->newImp->functions.push_back(newUF);
                    }
                    more_functions
     ;

more_implementations: /* empty */ { }
                    | TOK_STRING TOK_OPEN TOK_STRING TOK_HEXNUMBER
                    { if ($1 && $1->length() > 31)
                          throw ESyntaxeError(string("Used implementation name cannot be bigger than 31 chars."));
                      this->newImp = new Implementation;
                      this->newImp->name = $1;
                      this->newInt->imps.push_back(this->newImp);
                      if (!$3)
                          throw ESyntaxeError(string("Used function must have a name."));
                      UsedFunction *newUF = new UsedFunction;
                      newUF->name = $3;
                      newUF->number = $4;
                      this->newImp->functions.push_back(newUF);
                    }
                    more_functions TOK_CLOSE more_implementations
     ;

more_interfaces: /* empty */  { }
               | TOK_STRING TOK_HEXNUMBER TOK_OPEN TOK_STRING TOK_OPEN TOK_STRING TOK_HEXNUMBER
               { if (!$1)
                     throw ESyntaxeError(string("Used interface must have a name."));
                 if ($1->length() > 31)
                     throw ESyntaxeError(string("Used interface name cannot be bigger than 31 chars."));
                 this->newInt = new Interface;
                 this->newInt->name = $1;
                 this->newInt->prop = $2;
                 this->interfaces.push_back(this->newInt);
                 if ($4 && $4->length() > 31)
                     throw ESyntaxeError(string("Used implementation name cannot be bigger than 31 chars."));
                 this->newImp = new Implementation;
                 this->newImp->name = $4;
                 this->newInt->imps.push_back(this->newImp);
                 if (!$6)
                     throw ESyntaxeError(string("Used function must have a name."));
                 UsedFunction *newUF = new UsedFunction;
                 newUF->name = $6;
                 newUF->number = $7;
                 this->newImp->functions.push_back(newUF);
               }
               more_functions TOK_CLOSE more_implementations TOK_CLOSE more_interfaces
     ;

%%

void yyerror (char *s) {
    cout << s << endl;
}
