%{
#include <string>
#include "grammar.tab.h"
unsigned int lineNumber = 0;
%}

STRING \"[^\n"]*\"
INVALID_STR \"[^\n"]*\n
HEXNUMBER "0x"([0-9a-f]){1,8}
WS [ \t]+

%x COMMENT

%%

<INITIAL>{WS}  /* nothing */

<INITIAL>{STRING}   yytext[yyleng-1]= '\0'; if (*(yytext+1) == '\0') yylval.str = NULL; else yylval.str = new std::string(yytext+1); return TOK_STRING;

<INITIAL>{INVALID_STR}   cout << "Invalid string:" << lineNumber << ":" << YYText() << endl; exit(1);

<INITIAL>{HEXNUMBER}  yylval.uint = strtol(yytext, NULL, 16); return TOK_HEXNUMBER;

<INITIAL>\n  ++lineNumber;

<INITIAL>"header"  return TOK_HEADER;

<INITIAL>"usedfunctions"    return TOK_USEDFUNCTIONS;

<INITIAL>\{   return TOK_OPEN;

<INITIAL>\}   return TOK_CLOSE;

<INITIAL>"/*"  BEGIN(COMMENT);

<INITIAL>[0-9a-zA-Z]+    cout << "Invalid keyword: " << YYText() << endl; exit(1);

<INITIAL>.    cout << "Invalid caracter: " << YYText() << endl; exit(1);

<COMMENT>[^*\n]*          /* eat anything that's not a '*' */
<COMMENT>[^*\n]*\n        ++lineNumber;
<COMMENT>"*"+[^*/\n]*     /* eat up '*'s not followed by '/'s */
<COMMENT>"*"+[^*/\n]*\n   ++lineNumber;
<COMMENT>"*"+"/"          BEGIN(INITIAL);
<COMMENT><<EOF>>          cout << "Unexpect end of file while reading comment."; exit(1);

%%

int yywrap(void) {
  return 1;
}
