#ifndef COMMON_H
#define COMMON_H

#include <string>
#include <vector>

#define SYSTEM_FUNC 0x01
#define NOT_IMPLEMENTED_FUNC 0x01

struct Function {
    std::string *name;
    int prop;
    unsigned int start;
};

struct Implementation {
    std::string *name;
    std::vector<Function*> functions;
};

struct Interface {
    std::string *name;
    std::vector<Implementation*> implementations;
};

struct UsedFunction {
    std::string *name;
    unsigned int number;
};

struct UsedImplementation {
    std::string *name;
    std::vector<UsedFunction*> functions;
};

struct UsedInterface {
    std::string *name;
    unsigned int prop;
    std::vector<UsedImplementation*> imps;
};

#endif /*COMMON_H*/
