/*
* Bootloader - loads starter binary file from an ext2 filesystem into 0x100000
* Copyright (C) 2002, Luiz Henrique Shigunov (luizshigunov@users.sourceforge.net)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2, or (at your option)
* any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330,
* Boston, MA 02111-1307, USA.
*/

#include "shared.h"

#define STARTER "starter"

#define STARTER_MEM 0x100000

void cmain(void) {
    int ret;

    /* enable memory line a20 */
    gateA20(1);

    /* read starter */
    ret = read_file(STARTER, (char*)STARTER_MEM);

    /* put it on a known state */
    stop_floppy();

    if (ret)
        ((void(*)(void))STARTER_MEM)();

    /* something went wrong, stop! */
    stop();
}
