#ifndef BIOS_H
#define BIOS_H

/* The information for a disk geometry. The CHS information is only for
   DOS/Partition table compatibility, and the real number of sectors is
   stored in TOTAL_SECTORS.  */
struct geometry
{
  /* The number of cylinders */
  unsigned long cylinders;
  /* The number of heads */
  unsigned long heads;
  /* The number of sectors */
  unsigned long sectors;
  /* The total number of sectors */
  unsigned long total_sectors;
  /* Flags */
  unsigned long flags;
};

#define BIOSDISK_READ   0x0
#define BIOSDISK_WRITE  0x1

int bios_disk(int read, int drive, struct geometry *geometry, int sector, int nsec, int segment);
int bios_get_diskinfo(int drive, struct geometry *geometry);

#endif /*BIOS_H*/
