#ifndef MODULE_FILE_H
#define MODULE_FILE_H

#include "common.h"

typedef struct {
    char *name;
    unsigned int nFunctions;
} Module_Interface;

typedef struct {
    char *name;
} Module_Implementation;

typedef struct {
    unsigned int codeStart;
    unsigned int prop;
} Module_Function;

typedef struct {
    char md5[16];
    char *comment;
    void *phase0Start;
    void *phase1Start;
    void *shutdown;
    unsigned int codeSize;
    unsigned int dataSize;
    unsigned int version;
    unsigned int prop;
} Module_Module;

typedef struct {
    char *interface;
    char *imp;
    unsigned int function;
    unsigned int offset;
    unsigned int prop;
} Module_UsedFuncReloc;

void Module_GetFunctionsInfo(Module *module, unsigned int interface, unsigned int implementation, Module_Function *functions);
Module_Implementation *Module_GetImplementationInfo(Module *module, unsigned int interface, unsigned int implementation);
Module_Interface *Module_GetInterfaceInfo(Module *module, unsigned int interface);
Module_Module *Module_GetModuleInfo(Module *module);
Module_UsedFuncReloc *Module_GetUsedFuncReloc(Module *module, unsigned int i);
void Module_ReadCode(Module *module, char *buf, char *codePos, char *dataPos);
void Module_ReadData(Module *module, char *buf, char *codePos, char *dataPos);
/* returns: 0 - success; 1 - error */
int Module_CheckFile(Module *module);

#endif /*MODULE_FILE_H*/
