#if !defined(__COMMON_DEF_H)
#define __COMMON_DEF_H

/*
*****************************************
* Common chipset types, defines, ...
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 18/04/2002
*
* Copyright (C) 2000-2002, Luiz Henrique Shigunov
*****************************************
*/

#include <stddef.h>
#include <debug.h>
#include <errormanager.h>
#include <intmanager_i386.h>
#include <ioportmanager.h>
#include <memmanager_i386.h>
#include <sysmodmanager.h>
#include <taskmanager.h>

/* timer controller types and defines */
#define TimerController_i386_NUM_TIMERS 3
#define TimerController_i386_NUM_MODES 6

typedef struct {
	SysModManager_Module *module;
	unsigned int value;
	unsigned int config;
/*bcd	  : 1, BCD timer
  mode  : 3, operation mode
  rw    : 2, read or write from/to port
  timer : 2, timer number
*/
} TimerController_i386_Timer;


/* interrupt controller types and defines */
#define IntController_i386_ICW1        0x11  /* ICW1 value to send to PIC */
#define IntController_i386_masterICW3  0x4   /* ICW3 value to send to master PIC */
#define IntController_i386_slaveICW3   0x2   /* ICW3 value to send to slave PIC */
#define IntController_i386_ICW4        0x1   /* ICW4 value to send to PIC */


/* dma controller types and defines */
#define DMAController_i386_MAX_DMA_CHANNEL 7

typedef struct {
	SysModManager_Module *module;
	unsigned int physAddr;
	void *logAddr;
	unsigned int size;
} DMAController_i386_DMA_Channel;

#endif /* __COMMON_DEF_H */
