/*
*****************************************
* Interface AVLTree_In
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 24/06/2005
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2005, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(AVLTREE_IN_H)
#define AVLTREE_IN_H
#define AVLTree_In__ADD 0x00
#define AVLTree_In__COUNT 0x01
#define AVLTree_In__FIND 0x02
#define AVLTree_In__FINDADD 0x03
#define AVLTree_In__FINDCLOSE 0x04
#define AVLTree_In__FREE 0x05
#define AVLTree_In__ISEMPTY 0x06
#define AVLTree_In__REMOVE 0x07
#define AVLTree_in__WALK 0x08
typedef struct _AVLTree_In_Node {
struct _AVLTree_In_Node *left;
struct _AVLTree_In_Node *right;
signed char bal;
char cache;
char pad[2];
} AVLTree_In_Node;
typedef struct {
AVLTree_In_Node *root;
int (*cmpFunc)(const void*,const AVLTree_In_Node*);
int (*cmpAddFunc)(const AVLTree_In_Node*,const AVLTree_In_Node*);
unsigned int count;
} AVLTree_In_Tree;
int AVLTree_In_Add(AVLTree_In_Tree*,AVLTree_In_Node*);
unsigned int AVLTree_In_Count(const AVLTree_In_Tree*);
AVLTree_In_Node *AVLTree_In_Find(const AVLTree_In_Tree*,const void*);
AVLTree_In_Node *AVLTree_In_FindAdd(AVLTree_In_Tree*,AVLTree_In_Node*);
AVLTree_In_Node *AVLTree_In_FindClose(const AVLTree_In_Tree*,const void*);
int AVLTree_In_Free(AVLTree_In_Tree*,void(*)(AVLTree_In_Node*));
int AVLTree_In_IsEmpty(const AVLTree_In_Tree*);
AVLTree_In_Node *AVLTree_In_Remove(AVLTree_In_Tree*,const void*);
int AVLTree_In_Walk(const AVLTree_In_Tree*,void(*)(AVLTree_In_Node*,void*,void*),void*,void*);
#endif  /* AVLTREE_IN_H */
