/*
*****************************************
* Interface BlockBuffer
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 16/08/2002
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2002, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__BLOCKBUFFER_H)
#define __BLOCKBUFFER_H
#define BlockBuffer__FREEUNIT 0x00
#define BlockBuffer__GETBLOCK 0x01
#define BlockBuffer__GETBLOCKSIZE 0x02
#define BlockBuffer__GETHARDBLOCKSIZE 0x03
#define BlockBuffer__REGISTERUNIT 0x04
#define BlockBuffer__RELEASE 0x05
#define BlockBuffer__SETBLOCKSIZE 0x06
#ifndef __NO_BLOCKBUFFER_TYPES
struct _BlockBuffer_Block {char*data;void*avail1;void*avail2;unsigned int flags;unsigned int blockN;};
#endif
typedef struct _BlockBuffer_Unit BlockBuffer_Unit;
typedef struct _BlockBuffer_Block BlockBuffer_Block;
int BlockBuffer_FreeUnit(BlockBuffer_Unit*);
int BlockBuffer_GetBlock(BlockBuffer_Unit*,unsigned int,int,BlockBuffer_Block**);
int BlockBuffer_GetBlockSize(BlockBuffer_Unit*,unsigned int*);
int BlockBuffer_GetHardBlockSize(BlockBuffer_Unit*,unsigned int*);
int BlockBuffer_RegisterUnit(const char*,unsigned int,BlockBuffer_Unit**);
int BlockBuffer_Release(BlockBuffer_Unit*,BlockBuffer_Block*);
int BlockBuffer_SetBlockSize(BlockBuffer_Unit*,unsigned int);
#endif /* __BLOCKBUFFER_H */
