/*
*****************************************
* Interface BlockDev
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 25/01/2004
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2004, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__BLOCKDEV_H)
#define __BLOCKDEV_H
#define BlockDev__GETUNITDESC 0x01
#define BlockDev__GETUNITDESCINDEX 0x00
#define BlockDev__READ 0x02
#define BlockDev__WRITE 0x03
typedef struct {unsigned int unit;char *unitName;int type;int flags;unsigned int blockSize;unsigned int nBlocks;} BlockDev_UnitDesc;
typedef struct {unsigned int unit;unsigned int block;unsigned int n;void *buffer;unsigned int done;} BlockDev_IO;
#define BlockDev_TYPE_FLOPPY    0x01
#define BlockDev_TYPE_DISK      0x02
#define BlockDev_TYPE_CD_DVD    0x03
#define BlockDev_TYPE_TAPE      0x04
#define BlockDev_TYPE_UNKNOWN   0xff
#define BlockDev_F_REMOVABLE    0x01
#define BlockDev_F_READONLY     0x02
#define BlockDev_DO_NOT_READ    0x01
#define BlockDev_NO_NAME        0x02
int BlockDev_GetUnitDesc(unsigned int,BlockDev_UnitDesc*,unsigned int,int);
int BlockDev_GetUnitDescIndex(unsigned int,BlockDev_UnitDesc*,unsigned int,int);
int BlockDev_Read(BlockDev_IO*);
int BlockDev_Write(BlockDev_IO*);
#endif /* __BLOCKDEV_H */
