/*
*****************************************
* Interface CfgManager
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 07/08/2002
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2002, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__CFGMANAGER_H)
#define __CFGMANAGER_H
#define CfgManager__CLOSEGROUP 0x00
#define CfgManager__ENUMGROUP 0x01
#define CfgManager__ENUMKEY 0x02
#define CfgManager__GETVALUE 0x03
#define CfgManager__OPENGROUP 0x04
#define CfgManager__OPENGROUPINDEX 0x05
#define CfgManager__SETSYSTEMFILE 0x06
typedef struct _CfgManager_Group CfgManager_Group;
#define CfgManager_HEXNUMBER 0x01
#define CfgManager_STRING 0x02
int CfgManager_CloseGroup(CfgManager_Group*);
int CfgManager_EnumGroup(CfgManager_Group*,unsigned int,char*,unsigned int*);
int CfgManager_EnumKey(CfgManager_Group*,unsigned int,char*,unsigned int*);
int CfgManager_GetValue(CfgManager_Group*,const char*,int,void*,unsigned int*);
CfgManager_Group *CfgManager_OpenGroup(CfgManager_Group*,const char*);
CfgManager_Group *CfgManager_OpenGroupIndex(CfgManager_Group*,unsigned int);
int CfgManager_SetSystemFile(void*,unsigned int);
#endif  /* __CFGMANAGER_H */
