/*
*****************************************
* Interface ErrorManager
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 11/01/2004
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2004, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__ERRORMANAGER_H)
#define __ERRORMANAGER_H
#define IS_PTR_ERROR(x) ((unsigned int)(x) > (unsigned int)-4096L)
#define PTR_TO_ERROR(x) (-(int)(x))
#define ERROR_TO_PTR(x) ((void*)-(x))
#define E_OK                        0x00
#define E_BAD_INDEX                 0x01
#define E_BAD_VALUE                 0x02
#define E_BAD_TYPE                  0x03
#define E_MISMATCHED_VALUES         0x04
#define E_PERMISSION_DENIED         0x05
#define E_FAULT                     0x06
#define E_NOT_ALLOWED               0x07
#define E_NOT_INIT                  0x08
#define E_NOT_FOUND                 0x09
#define E_NOT_READY                 0x0a
#define E_NOT_EMPTY                 0x0b
#define E_NOT_IN_USE                0x0c
#define E_EMPTY                     0x0d
#define E_IN_USE                    0x0e
#define E_BUSY                      0x0f
#define E_TIMED_OUT                 0x10
#define E_INTERRUPTED               0x11
#define E_WOULD_BLOCK               0x12
#define E_IO_ERROR                  0x13
#define E_TOO_BIG                   0x14
#define E_UNSUPPORTED               0x15
#define E_END_REACHED               0x16
#define E_NO_MEMORY                 0x17
#define E_REGISTERED                0x18
#define E_NOT_REGISTERED            0x19
#define E_UNDEFINED                 0x1a
#define E_NOT_IMPLEMENTED           0x1b
#define E_BUG                       0x1c
#define E_NOT_USER_TASK             0x1d
#define E_NO_SUCH_UNIT              0x1e
#define E_BUFFER_TOO_SMALL          0x1f
#define E_NO_SUCH_DRIVE             0x20
#define E_NO_SUCH_INTERFACE         0x21
#define E_INVALID_VERSION           0x22
#define E_PROBE_FAILED              0x23
#define E_NO_SUCH_IMPLEMENTATION    0x24

#define E_FILE_ERROR                0x30
#define E_FILE_EXISTS               0x31
#define E_TOO_MANY_OPEN_FILES       0x32
#define E_NOT_A_DIRECTORY           0x33
#define E_IS_A_DIRECTORY            0x34
#define E_FS_FULL                   0x35
#define E_READ_ONLY_FS              0x36
#define E_CORRUPTED_FS              0x37
#define E_LOOP                      0x38
#define E_NOT_FILE_DIR              0x39

#define E_NO_MEDIA                  0x40
#define E_MEDIA_CHANGED             0x41
#define E_FORMAT_ERROR              0x42
#define E_READ_ONLY_DEVICE          0x43

#define E_LOADING_MODULE            0x50
#define E_STARTING_MODULE           0x51
#define E_SHUTTINGDOWN_MODULE       0x52
#define E_INTERFACE_NOT_IMPLEMENTED 0x53
#define E_BAD_FUNCTION_TYPE         0x54
#define E_MODULE                    0x55

#define E_HANDLED_INT               0x70
#define E_UNHANDLED_INT             0x71
#define E_INVOKE_SCHEDULER          0x72
#endif /* __ERRORMANAGER_H */
