/*
*****************************************
* Interface FileSystem
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 02/03/2003
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2003, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__FILESYSTEM_H)
#define __FILESYSTEM_H
#define FileSystem__CLOSE 0x00
#define FileSystem__LOOKUP 0x0e
#define FileSystem__MOUNT 0x02
#define FileSystem__OPEN 0x03
#define FileSystem__READ 0x05
#define FileSystem__READLINK 0x0f
#define FileSystem__REMOVE 0x07
#define FileSystem__REWINDDIR 0x09
#define FileSystem__SEEK 0x0a
#define FileSystem__STATUS 0x0b
#define FileSystem__STATUSFD 0x01
#define FileSystem__UNMOUNT 0x0c
#define FileSystem__WRITE 0x0d
typedef struct _FileSystem_Handle FileSystem_Handle;
#include "fsmanager.h"
void FileSystem_Close(FileSystem_Handle*);
int FileSystem_Lookup(FSManager_Dentry*,FSManager_Dentry*);
int FileSystem_Mount(const char*,unsigned int,int,const char*,FSManager_Dentry*);
int FileSystem_Open(FSManager_Dentry*,int,FileSystem_Handle**);
int FileSystem_Read(FSManager_FDIO*);
int FileSystem_ReadLink(FSManager_Dentry*,char*,unsigned int);
int FileSystem_Remove(FSManager_Dentry*);
int FileSystem_RewindDir(FileSystem_Handle*);
int FileSystem_Seek(FileSystem_Handle*,int,int,int*);
int FileSystem_Status(FSManager_Dentry*,FSManager_EntryStatus*,int);
int FileSystem_StatusFD(FileSystem_Handle*,FSManager_EntryStatus*,int);
int FileSystem_Unmount(FSManager_Dentry*,int);
int FileSystem_Write(FSManager_FDIO*);
#endif /* __FILESYSTEM_H */
