/*
*****************************************
* Interface IdeController
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 14/12/2003
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2003, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__IDECONTROLLER_H)
#define __IDECONTROLLER_H
#define IdeController__GETDRIVE 0x00
#define IdeController__LOCKINTERFACE 0x01
#define IdeController__PUTDRIVE 0x02
#define IdeController__READDATA 0x03
#define IdeController__SENDREQUEST 0x04
#define IdeController__SETUPDRIVE 0x05
#define IdeController__UNLOCKINTERFACE 0x06
#define IdeController__WRITEDATA 0x07
#define IdeController_MODE_MASK 0x0f
#define IdeController_ONE_SECTOR 0x00
#define IdeController_PROBE_MODE 0x01
#define IdeController_START_MULTISECTOR 0x02
#define IdeController_CONT_MULTISECTOR 0x03
#define IdeController_END_MULTISECTOR 0x04
#define IdeController_FEATURE_PORT 0x00
#define IdeController_SECTOR_COUNT_PORT 0x01
#define IdeController_SECTOR_NUMBER_PORT 0x02
#define IdeController_LOW_CYL_PORT 0x03
#define IdeController_HIGH_CYL_PORT 0x04
#define IdeController_DRIVE_PORT 0x05
#define IdeController_COMMAND_PORT 0x06
#define IdeController_SETUP_LBA 0x01
typedef struct {unsigned char port;unsigned char data;} IdeController_RequestPort;
typedef struct {unsigned int version;unsigned int interface;unsigned int drive;unsigned int timeout;int flags;
unsigned int numIOs;unsigned char status;unsigned char error;IdeController_RequestPort IOs[1];} IdeController_Request;
typedef struct {unsigned int version;unsigned int interface;unsigned int drive;int flags;} IdeController_Setup;
/* system functions */
int IdeController_GetDrive(unsigned int,unsigned int);
int IdeController_LockInterface(unsigned int);
int IdeController_PutDrive(unsigned int,unsigned int);
int IdeController_ReadData(unsigned int,void*,unsigned int);
int IdeController_SendRequest(IdeController_Request*);
int IdeController_SetupDrive(const IdeController_Setup*);
int IdeController_UnlockInterface(unsigned int);
int IdeController_WriteData(unsigned int,const void*,unsigned int);
#endif /* __IDECONTROLLER_H */
