/*
*****************************************
* Interface InterManager
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 11/07/2003
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2003, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__INTERMANAGER_H)
#define __INTERMANAGER_H
#define InterManager__GETINPUTINFO 0x08
#define InterManager__GETOUTPUTINFO 0x09
#define InterManager__REGISTERINPUT 0x00
#define InterManager__REGISTEROUTPUT 0x01
#define InterManager__SENDEVENT 0x02
#define InterManager__UFLUSHEVENTQUEUE 0x03
#define InterManager__UGETINPUTINFO 0x04
#define InterManager__UGETOUTPUTINFO 0x05
#define InterManager__USETFOCUS 0x06
#define InterManager__UWAITEVENT 0x07
typedef struct {unsigned int type;unsigned int data[7];}InterManager_Event;
typedef struct {unsigned short interSize;unsigned short impSize;char names[1];} InterManager_InputInfo;
typedef struct {unsigned short interSize;unsigned short impSize;char names[1];} InterManager_OutputInfo;
#define InterManager_DO_NOT_BLOCK 0x01
#include "taskmanager.h"
int InterManager_GetInputInfo(unsigned int,InterManager_InputInfo*,unsigned int);
int InterManager_GetOutputInfo(InterManager_OutputInfo*,unsigned int);
int InterManager_RegisterInput(TaskManager_Task*,const char*);
int InterManager_RegisterOutput(TaskManager_Task*,const char*);
int InterManager_SendEvent(TaskManager_Task*,const InterManager_Event*);
void InterManager_UFlushEventQueue(int);
int InterManager_UGetInputInfo(unsigned int,InterManager_InputInfo*,unsigned int);
int InterManager_UGetOutputInfo(InterManager_OutputInfo*,unsigned int);
int InterManager_USetFocus(int);
int InterManager_UWaitEvent(InterManager_Event*,int);
#endif /* __INTERMANAGER_H */
