/*
*****************************************
* Interface IntManager_i386
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 11/10/2003
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2003, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__INTMANAGER_I386_H)
#define __INTMANAGER_I386_H
#define IntManager_i386__CATCH 0x00
#define IntManager_i386__CATCHEXCEPTION 0x04
#define IntManager_i386__FREE 0x01
#define IntManager_i386__FREEEXCEPTION 0x05
#define IntManager_i386__NOINT 0x02
#define IntManager_i386__RESTOREINT 0x03
typedef struct {
unsigned int EBP;
unsigned int ESI;
unsigned int EDI;
unsigned int EDX;
unsigned int ECX;
unsigned int EBX;
unsigned int EAX;
unsigned int ErrorCode;
unsigned int EIP;
unsigned int CS;
unsigned int EFLAGS;
unsigned int ESP;
unsigned int SS;
} IntManager_i386_ExRegs;
typedef struct {
unsigned int EBP;
unsigned int ESI;
unsigned int EDI;
unsigned int EDX;
unsigned int ECX;
unsigned int EBX;
unsigned int EAX;
unsigned int EIP;
unsigned int CS;
unsigned int EFLAGS;
unsigned int ESP;
unsigned int SS;
} IntManager_i386_Regs;
#define IntManager_i386_HARD_INT        0x01
#define IntManager_i386_PRIV_SOFT_INT   0x02
#define IntManager_i386_LAST_INT        0x04
#include "sysmodmanager.h"
int IntManager_i386_Catch(SysModManager_Module*,unsigned int,int(*)(IntManager_i386_Regs*),int);
int IntManager_i386_CatchException(unsigned int,int(*)(IntManager_i386_ExRegs*),void*,void*);
int IntManager_i386_Free(SysModManager_Module*,unsigned int,int);
int IntManager_i386_FreeException(unsigned int,int(*)(IntManager_i386_ExRegs*),void*);
int IntManager_i386_NoInt(void);
void IntManager_i386_RestoreInt(int);
#endif  /* __INTMANAGER_I386_H */
