/*
*****************************************
* Interface IOPortManager_i386
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 14/12/2003
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2003, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__IOPORTMANAGER_I386_H)
#define __IOPORTMANAGER_I386_H
static __inline__ unsigned char IOPortManager_i386_InChar(unsigned short port) {
    unsigned char value;
    __asm__ __volatile__ ("inb %w1, %0" : "=a" (value) : "d" (port));
    return value;
}
static __inline__ void IOPortManager_i386_InChars(unsigned short port, void *addr, unsigned int size) {
    __asm__ __volatile__ ("rep; insb" : "=D" (addr), "=c" (size) : "d" (port), "0" (addr), "1" (size));
}
static __inline__ unsigned short IOPortManager_i386_InShort(unsigned short port) {
    unsigned short value;
    __asm__ __volatile__ ("inw %w1, %0" : "=a" (value) : "d" (port));
    return value;
}
static __inline__ void IOPortManager_i386_InShorts(unsigned short port, void *addr, unsigned int size) {
    __asm__ __volatile__ ("rep; insw" : "=D" (addr), "=c" (size) : "d" (port), "0" (addr), "1" (size));
}
static __inline__ unsigned int IOPortManager_i386_InInt(unsigned short port) {
    unsigned int value;
    __asm__ __volatile__ ("inl %w1, %0" : "=a" (value) : "d" (port));
    return value;
}
static __inline__ void IOPortManager_i386_InInts(unsigned short port, void *addr, unsigned int size) {
    __asm__ __volatile__ ("rep; insl" : "=D" (addr), "=c" (size) : "d" (port), "0" (addr), "1" (size));
}
static __inline__ void IOPortManager_i386_OutChar(unsigned short port, unsigned char value) {
    __asm__ __volatile__ ("outb %b0, %w1" : : "a" (value), "d" (port));
}
static __inline__ void IOPortManager_i386_OutChars(unsigned short port, const void *addr, unsigned int size) {
    __asm__ __volatile__ ("rep; outsb" : "=S" (addr), "=c" (size) : "d" (port), "0" (addr), "1" (size));
}
static __inline__ void IOPortManager_i386_OutShort(unsigned short port, unsigned short value) {
    __asm__ __volatile__ ("outw %w0, %w1" : : "a" (value), "d" (port));
}
static __inline__ void IOPortManager_i386_OutShorts(unsigned short port, const void *addr, unsigned int size) {
    __asm__ __volatile__ ("rep; outsw" : "=S" (addr), "=c" (size) : "d" (port), "0" (addr), "1" (size));
}
static __inline__ void IOPortManager_i386_OutInt(unsigned short port, unsigned int value) {
    __asm__ __volatile__ ("outl %0, %w1" : : "a" (value), "d" (port));
}
static __inline__ void IOPortManager_i386_OutInts(unsigned short port, const void *addr, unsigned int size) {
    __asm__ __volatile__ ("rep; outsl" : "=S" (addr), "=c" (size) : "d" (port), "0" (addr), "1" (size));
}
#endif /* __IOPORTMANAGER_I386_H */
