/*
*****************************************
* Interface Keyboard
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 24/11/2002
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2002, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__KEYBOARD_H)
#define __KEYBOARD_H
typedef struct {unsigned int type;unsigned short charCode;unsigned char vKey;unsigned char reserved;unsigned int flags;unsigned int reserved2[5];}Keyboard_Event;
typedef struct {unsigned short interSize;unsigned short impSize;char names[1];} Keyboard_LayoutInfo;
#define Keyboard_VK_0                0x01
#define Keyboard_VK_1                0x02
#define Keyboard_VK_2                0x03
#define Keyboard_VK_3                0x04
#define Keyboard_VK_4                0x05
#define Keyboard_VK_5                0x06
#define Keyboard_VK_6                0x07
#define Keyboard_VK_7                0x08
#define Keyboard_VK_8                0x09
#define Keyboard_VK_9                0x0a
#define Keyboard_VK_A                0x0b
#define Keyboard_VK_B                0x0c
#define Keyboard_VK_C                0x0d
#define Keyboard_VK_D                0x0e
#define Keyboard_VK_E                0x0f
#define Keyboard_VK_F                0x10
#define Keyboard_VK_G                0x11
#define Keyboard_VK_H                0x12
#define Keyboard_VK_I                0x13
#define Keyboard_VK_J                0x14
#define Keyboard_VK_K                0x15
#define Keyboard_VK_L                0x16
#define Keyboard_VK_M                0x17
#define Keyboard_VK_N                0x18
#define Keyboard_VK_O                0x19
#define Keyboard_VK_P                0x1a
#define Keyboard_VK_Q                0x1b
#define Keyboard_VK_R                0x1c
#define Keyboard_VK_S                0x1d
#define Keyboard_VK_T                0x1e
#define Keyboard_VK_U                0x1f
#define Keyboard_VK_V                0x20
#define Keyboard_VK_W                0x21
#define Keyboard_VK_X                0x22
#define Keyboard_VK_Y                0x23
#define Keyboard_VK_Z                0x24
#define Keyboard_VK_SPACE            0x25
#define Keyboard_VK_KEYPAD0          0x26
#define Keyboard_VK_KEYPAD1          0x27
#define Keyboard_VK_KEYPAD2          0x28
#define Keyboard_VK_KEYPAD3          0x29
#define Keyboard_VK_KEYPAD4          0x2a
#define Keyboard_VK_KEYPAD5          0x2b
#define Keyboard_VK_KEYPAD6          0x2c
#define Keyboard_VK_KEYPAD7          0x2d
#define Keyboard_VK_KEYPAD8          0x2e
#define Keyboard_VK_KEYPAD9          0x2f
#define Keyboard_VK_KEYPAD_DIV       0x30
#define Keyboard_VK_KEYPAD_MUL       0x31
#define Keyboard_VK_KEYPAD_MINUS     0x32
#define Keyboard_VK_KEYPAD_PLUS      0x33
#define Keyboard_VK_KEYPAD_DOT       0x34
#define Keyboard_VK_KEYPAD_COMMA     0x35
#define Keyboard_VK_PUNCT0           0x36
#define Keyboard_VK_PUNCT1           0x37
#define Keyboard_VK_PUNCT2           0x38
#define Keyboard_VK_PUNCT3           0x39
#define Keyboard_VK_PUNCT4           0x3a
#define Keyboard_VK_PUNCT5           0x3b
#define Keyboard_VK_PUNCT6           0x3c
#define Keyboard_VK_PUNCT7           0x3d
#define Keyboard_VK_PUNCT8           0x3e
#define Keyboard_VK_PUNCT9           0x3f
#define Keyboard_VK_PUNCT10          0x40
#define Keyboard_VK_PUNCT11          0x41
#define Keyboard_VK_PUNCT12          0x42
#define Keyboard_VK_PUNCT13          0x43
#define Keyboard_VK_PUNCT14          0x44
#define Keyboard_VK_PUNCT15          0x45
#define Keyboard_VK_PUNCT16          0x46
#define Keyboard_VK_PUNCT17          0x47
#define Keyboard_VK_PUNCT18          0x48
#define Keyboard_VK_PUNCT19          0x49
#define Keyboard_VK_PUNCT20          0x4a
#define Keyboard_VK_ESC              0x4b
#define Keyboard_VK_BACK             0x4c
#define Keyboard_VK_TAB              0x4d
#define Keyboard_VK_RETURN           0x4e
#define Keyboard_VK_KEYBAD_RETURN    0x4f
#define Keyboard_VK_LSHIFT           0x50
#define Keyboard_VK_RSHIFT           0x51
#define Keyboard_VK_LCTRL            0x52
#define Keyboard_VK_RCTRL            0x53
#define Keyboard_VK_LALT             0x54
#define Keyboard_VK_RALT             0x55
#define Keyboard_VK_PAGEUP           0x56
#define Keyboard_VK_PAGEDOWN         0x57
#define Keyboard_VK_HOME             0x58
#define Keyboard_VK_END              0x59
#define Keyboard_VK_INSERT           0x5a
#define Keyboard_VK_DELETE           0x5b
#define Keyboard_VK_UP               0x5c
#define Keyboard_VK_DOWN             0x5d
#define Keyboard_VK_LEFT             0x5e
#define Keyboard_VK_RIGHT            0x5f
#define Keyboard_VK_NUMLOCK          0x60
#define Keyboard_VK_CAPSLOCK         0x61
#define Keyboard_VK_SCROLLLOCK       0x62
#define Keyboard_VK_SYSRQ            0x63
#define Keyboard_VK_PAUSE            0x64
#define Keyboard_VK_F1               0x65
#define Keyboard_VK_F2               0x66
#define Keyboard_VK_F3               0x67
#define Keyboard_VK_F4               0x68
#define Keyboard_VK_F5               0x69
#define Keyboard_VK_F6               0x6a
#define Keyboard_VK_F7               0x6b
#define Keyboard_VK_F8               0x6c
#define Keyboard_VK_F9               0x6d
#define Keyboard_VK_F10              0x6e
#define Keyboard_VK_F11              0x6f
#define Keyboard_VK_F12              0x70
#define Keyboard_VK_F13              0x71
#define Keyboard_VK_F14              0x72
#define Keyboard_VK_F15              0x73
#define Keyboard_VK_F16              0x74
#define Keyboard_VK_F17              0x75
#define Keyboard_VK_F18              0x76
#define Keyboard_VK_F19              0x77
#define Keyboard_VK_F20              0x78
#define Keyboard_VK_F21              0x79
#define Keyboard_VK_F22              0x7a
#define Keyboard_VK_F23              0x7b
#define Keyboard_VK_F24              0x7c
#define Keyboard_VK_LWIN             0x7d
#define Keyboard_VK_RWIN             0x7e
#define Keyboard_VK_MENU             0x7f
#define Keyboard_VK_MACRO            0x80
const char *Keyboard_GetLayout(void);
int Keyboard_SetLayout(const char*);
int Keyboard_UGetLayout(Keyboard_LayoutInfo*,unsigned int);
int Keyboard_USetLayout(const char*);
#endif /* __KEYBOARD_H */
