/*
*****************************************
* Interface MemManager
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 14/02/2002
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2002, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__USER_MEMMANAGER_H)
#define __USER_MEMMANAGER_H
#define User_MemManager__ALLOC 0x00
#define User_MemManager__ALLOCALIGN 0x01
#define User_MemManager__ALLOCCLEAR 0x02
#define User_MemManager__ALLOCPAGEALIGN 0x03
#define User_MemManager__ALLOCPAGEROUND 0x04
#define User_MemManager__FREE 0x05
#define User_MemManager__GETMEMSTATS 0x06
#define User_MemManager__GETUSABLESIZE 0x07
#define User_MemManager__MEMTRIM 0x08
#define User_MemManager__REALLOC 0x09
#define User_MemManager__SETMEMOPTION 0x0a
typedef struct {unsigned int totalMem;unsigned int allocAreas;unsigned int totalAreas;unsigned int totalAlloc;unsigned int totalFree;unsigned int trimArea;} User_MemManager_MemoryStats;
void *User_MemManager_Alloc(unsigned int);
void *User_MemManager_AllocAlign(unsigned int,unsigned int);
void *User_MemManager_AllocClear(unsigned int,unsigned int);
void *User_MemManager_AllocPageAlign(unsigned int);
void *User_MemManager_AllocPageRound(unsigned int);
void User_MemManager_Free(void*);
User_MemManager_MemoryStats User_MemManager_GetMemStats(void);
unsigned int User_MemManager_GetUsableSize(void*);
int User_MemManager_MemTrim(unsigned int);
void *User_MemManager_ReAlloc(void*,unsigned int);
int User_MemManager_SetMemOption(int,void*);
#endif /* __USER_MEMMANAGER_H */
