/*
*****************************************
* Interface StringMan
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 13/02/2002
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2002, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__USER_STRINGMAN_H)
#define __USER_STRINGMAN_H
#include <stdarg.h>
#define User_StringMan__COMPARE 0x00
#define User_StringMan__CONCATENATE 0x01
#define User_StringMan__COPY 0x02
#define User_StringMan__FINDCHAR 0x03
#define User_StringMan__FINDLASTCHAR 0x04
#define User_StringMan__LENGTH 0x05
#define User_StringMan__NCOMPARE 0x06
#define User_StringMan__NCONCATENATE 0x07
#define User_StringMan__NCOPY 0x08
#define User_StringMan__BUFPRINTF 0x09
#define User_StringMan__BUFPRINTFARGS 0x0a
#define User_StringMan__STRTOINT 0x0b
int User_StringMan_Compare(const char*,const char*);
void User_StringMan_Concatenate(char*,const char*);
void User_StringMan_Copy(char*,const char*);
char *User_StringMan_FindChar(const char*,int);
char *User_StringMan_FindLastChar(const char*,int);
unsigned int User_StringMan_Length(const char*);
int User_StringMan_NCompare(const char*,const char*,unsigned int);
void User_StringMan_NConcatenate(char*,const char*,unsigned int);
void User_StringMan_NCopy(char*,const char*,unsigned int);
int User_StringMan_BufPrintF(char*,const char*,...);
int User_StringMan_BufPrintFArgs(char*,const char*,va_list);
long int User_StringMan_StrToInt(const char*,char**,int,int*);
#endif /* __USER_STRINGMAN_H */
