/*
*****************************************
* Interface MemManager
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 01/06/2003
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2003, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__MEMMANAGER_H)
#define __MEMMANAGER_H
#define MemManager__ALLOC 0x00
#define MemManager__ALLOCOBJ 0x01
#define MemManager__ALLOCUSERPAGES 0x06
#define MemManager__ATTACHSHMEMORY 0x07
#define MemManager__CREATEOBJCACHE 0x02
#define MemManager__CREATESHMEMORY 0x08
#define MemManager__DESTROYOBJCACHE 0x03
#define MemManager__DESTROYSHMEMORY 0x09
#define MemManager__DETACHSHMEMORY 0x0a
#define MemManager__FREE 0x04
#define MemManager__FREEOBJ 0x05
#define MemManager__FREEUSERPAGES 0x0b
#define MemManager__MAPPAGEATUSERPAGE 0x0c
#define MemManager__PROTECTSHMEMORY 0x0d
#define MemManager__SETUSERPAGESPROT 0x0e
#define MemManager__UALLOCUSERPAGES 0x0f
#define MemManager__UFREEUSERPAGES 0x10
#define MemManager__USETUSERPAGESPROT 0x11
typedef struct _MemManager_Cache MemManager_Cache;
typedef struct _MemManager_ShMem MemManager_ShMem;
typedef struct _MemManager_ShMemFunctions {int(*readpage)(void*,void*,unsigned int);} MemManager_ShMemFunctions;
#define MemManager_BLOCK_MEM 0x01
#define MemManager_PROT_NONE 0x00
#define MemManager_PROT_EXEC 0x01
#define MemManager_PROT_WRITE 0x02
#define MemManager_PROT_READ 0x04
#define MemManager_CLEAR_PAGE 0x08
#define MemManager_ONLY_SYS 0x10
#define MemManager_MAP_FLAGS_MASK 0xff
#define MemManager_MAP_USER_FLAGS_MASK 0x07
#define MemManager_FIXED_ADDR 0x1000
#define MemManager_FAIL_MAPPED 0x2000
#define MemManager_CHANGE_SYS 0x1000
#define MemManager_CLEAR_OBJS 0x01
#define MemManager_SH_PDE 0x01
#define MemManager_SH_CLEAR 0x02
#include <taskmanager.h>
void *MemManager_Alloc(unsigned int,int);
void *MemManager_AllocObj(MemManager_Cache*);
void *MemManager_AllocUserPages(void*,unsigned int,unsigned int,int,TaskManager_Task*);
void *MemManager_AttachShMemory(MemManager_ShMem*,void*,unsigned int,unsigned int,int,TaskManager_Task*);
MemManager_Cache *MemManager_CreateObjCache(unsigned int,unsigned int,int,void(*)(void*,unsigned int),void(*)(void*,unsigned int));
MemManager_ShMem *MemManager_CreateShMemory(unsigned int,int,const MemManager_ShMemFunctions*,void*);
int MemManager_DestroyObjCache(MemManager_Cache*);
int MemManager_DestroyShMemory(MemManager_ShMem*);
int MemManager_DetachShMemory(MemManager_ShMem*,void*,unsigned int,int,TaskManager_Task*);
int MemManager_Free(void*);
int MemManager_FreeObj(MemManager_Cache*,void*);
int MemManager_FreeUserPages(void*,unsigned int,int,TaskManager_Task*);
int MemManager_MapPageAtUserPage(void*,unsigned int,TaskManager_Task*);
int MemManager_ProtectShMemory(MemManager_ShMem*,const void*,unsigned int,int,TaskManager_Task*);
int MemManager_SetUserPagesProt(const void*,unsigned int,int,TaskManager_Task*);
void *MemManager_UAllocUserPages(void*,unsigned int,unsigned int,int);
int MemManager_UFreeUserPages(void*,unsigned int);
int MemManager_USetUserPagesProt(const void*,unsigned int,int);
#endif /* __MEMMANAGER_H */
