/*
*****************************************
* Interface MemManager_i386
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 08/06/2005
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2005, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__MEMMANAGER_I386_H)
#define __MEMMANAGER_I386_H
#define MemManager_i386__ALLOCPAGES 0x00
#define MemManager_i386__ALLOCPHYSPAGES 0x01
#define MemManager_i386__BLOCK 0x02
#define MemManager_i386__CATCH 0x03
#define MemManager_i386__CREATEDESCRIPTOR 0x04
#define MemManager_i386__CREATEPGD 0x05
#define MemManager_i386__DESTROYDESCRIPTOR 0x06
#define MemManager_i386__FREEEXCEPTION 0x07
#define MemManager_i386__FREEPAGES 0x08
#define MemManager_i386__FREEPHYSPAGES 0x09
#define MemManager_i386__MAPPHYSPAGES 0x0a
#define MemManager_i386__SETPAGESPROP 0x0b
#define MemManager_i386__UNBLOCK 0x0c
#ifndef __NO_MEMMANAGER_I386_TYPES
struct _MemManager_i386_SegDescriptor {unsigned short limit15;unsigned short base15;unsigned int base23:8,type:4,s:1,dpl:2,p:1,limit19:4,avl:1,reserved:1,db:1,g:1,base31:8;};
#endif
typedef struct _MemManager_i386_SegDescriptor MemManager_i386_SegDescriptor;
#define MemManager_i386_EX_RETURN 0x02
#define MemManager_i386_EX_USER_MODE 0x04
#define MemManager_i386_RW_PAGE 0x01
#define MemManager_i386_USER_PAGE 0x02
#define MemManager_i386_WT_PAGE 0x04
#define MemManager_i386_CD_PAGE 0x08
#define MemManager_i386_ALLOC_PHYS 0x1000
#define MemManager_i386_CLEAR_PAGES 0x2000
#define MemManager_i386_BLOCK_PAGE 0x01
#define MemManager_i386_LESS_1MB 0x02
#define MemManager_i386_LESS_16MB 0x04
#define MemManager_i386_BOUNDARY_64KB 0x08
#define MemManager_i386_DONT_FREE_PHYS 0x01
#define MemManager_i386_ALLOC_PAGES 0x1000
#define MemManager_i386_DONT_INV_TLB 0x1000
void *MemManager_i386_AllocPages(unsigned int,int);
unsigned int MemManager_i386_AllocPhysPages(unsigned int,int);
int MemManager_i386_Block(void*,unsigned int);
int MemManager_i386_Catch(void*,void*,void*,int);
int MemManager_i386_CreateDescriptor(MemManager_i386_SegDescriptor,unsigned short*);
unsigned int MemManager_i386_CreatePGD(void);
int MemManager_i386_DestroyDescriptor(unsigned int);
int MemManager_i386_FreeException(void*,void*,int);
int MemManager_i386_FreePages(void*,unsigned int,int);
int MemManager_i386_FreePhysPages(unsigned int,unsigned int);
void *MemManager_i386_MapPhysPages(void*,unsigned int,unsigned int,int);
int MemManager_i386_SetPagesProp(void*,unsigned int,int);
int MemManager_i386_Unblock(void*,unsigned int);
#endif /* __MEMMANAGER_I386_H */
