/*
*****************************************
* Interface RExecModFile
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 23/03/2003
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2003, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__REXECMODFILE_H)
#define __REXECMODFILE_H
#define RExecModFile__CLOSE 0x00
#define RExecModFile__CHECKFORMAT 0x09
#define RExecModFile__GETMODULEINFO 0x01
#define RExecModFile__GETUSEDFUNC 0x02
#define RExecModFile__GETUSEDFUNCRELOC 0x03
#define RExecModFile__LOADCODE 0x04
#define RExecModFile__LOADDATA 0x05
#define RExecModFile__LOADRODATA 0x06
#define RExecModFile__OPEN 0x07
#define RExecModFile__OPENFD 0x08
#define RExecModFile_DO_NOT_CLOSE 0x01
#define RExecModFile_RELOC_ABS 0x01
typedef struct _RExecModFile_File RExecModFile_File;
typedef struct {char md5[16];const char *comment;unsigned int codeSize;unsigned int roDataSize;unsigned int dataSize;unsigned int stackSize;} RExecModFile_ModuleInfo;
typedef struct {const char *interface;const char *imp;unsigned int function;unsigned int prop;} RExecModFile_UsedFuncInfo;
typedef struct {RExecModFile_UsedFuncInfo function;unsigned int offset;unsigned int prop;} RExecModFile_UsedFuncRelocInfo;
#include <fsmanager.h>
int RExecModFile_Close(RExecModFile_File*);
int RExecModFile_CheckFormat(void*,unsigned int);
int RExecModFile_GetModuleInfo(RExecModFile_File*,RExecModFile_ModuleInfo*);
int RExecModFile_GetUsedFunc(RExecModFile_File*,unsigned int,RExecModFile_UsedFuncInfo*);
int RExecModFile_GetUsedFuncReloc(RExecModFile_File*,unsigned int,RExecModFile_UsedFuncRelocInfo*);
int RExecModFile_LoadCode(RExecModFile_File*,unsigned int,unsigned int,void*);
int RExecModFile_LoadData(RExecModFile_File*,unsigned int,unsigned int,void*);
int RExecModFile_LoadROData(RExecModFile_File*,unsigned int,unsigned int,void*);
int RExecModFile_Open(const char*,RExecModFile_File**);
int RExecModFile_OpenFD(FSManager_Handle*,int,RExecModFile_File**);
#endif /* __REXECMODFILE_H */
