/*
*****************************************
* Interface RLibModFile
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 16/08/2002
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2002, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__RLIBMODFILE_H)
#define __RLIBMODFILE_H
#define RLibModFile__CLOSE 0x00
#define RLibModFile__GETFUNCSINFO 0x01
#define RLibModFile__GETIMPINFO 0x02
#define RLibModFile__GETINTERINFO 0x03
#define RLibModFile__GETMODULEINFO 0x04
#define RLibModFile__GETUSEDFUNC 0x05
#define RLibModFile__GETUSEDFUNCRELOC 0x06
#define RLibModFile__LOADCODE 0x07
#define RLibModFile__LOADDATA 0x08
#define RLibModFile__LOADRODATA 0x09
#define RLibModFile__OPEN 0x0a
typedef struct _RLibModFile_File RLibModFile_File;
typedef struct {unsigned int codeStart;unsigned int prop;} RLibModFile_FunctionInfo;
typedef struct {const char *name;} RLibModFile_ImpInfo;
typedef struct {const char *name;unsigned int nFunctions;} RLibModFile_InterInfo;
typedef struct {char md5[16];const char *comment;void *start;void *shutdown;unsigned int codeSize;unsigned int roDataSize;unsigned int dataSize;unsigned int version;unsigned int prop;} RLibModFile_ModuleInfo;
typedef struct {const char *interface;const char *imp;unsigned int function;unsigned int prop;} RLibModFile_UsedFuncInfo;
typedef struct {RLibModFile_UsedFuncInfo function;unsigned int offset;unsigned int prop;} RLibModFile_UsedFuncRelocInfo;
int RLibModFile_Close(RLibModFile_File*);
int RLibModFile_GetFuncsInfo(RLibModFile_File*,unsigned int,unsigned int,RLibModFile_FunctionInfo*);
int RLibModFile_GetImpInfo(RLibModFile_File*,unsigned int,unsigned int,RLibModFile_ImpInfo*);
int RLibModFile_GetInterInfo(RLibModFile_File*,unsigned int,RLibModFile_InterInfo*);
int RLibModFile_GetModuleInfo(RLibModFile_File*,RLibModFile_ModuleInfo*);
int RLibModFile_GetUsedFunc(RLibModFile_File*,unsigned int,RLibModFile_UsedFuncInfo*);
int RLibModFile_GetUsedFuncReloc(RLibModFile_File*,unsigned int,RLibModFile_UsedFuncRelocInfo*);
int RLibModFile_LoadCode(RLibModFile_File*,unsigned int,unsigned int,void*,void*,void*,void*);
int RLibModFile_LoadData(RLibModFile_File*,unsigned int,unsigned int,void*,void*,void*,void*);
int RLibModFile_LoadROData(RLibModFile_File*,unsigned int,unsigned int,void*,void*,void*,void*);
int RLibModFile_Open(const char*,RLibModFile_File**);
#endif /* __RLIBMODFILE_H */
