/*
*****************************************
* Interface RSysModFile
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 16/08/2002
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2002, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__RSYSMODFILE_H)
#define __RSYSMODFILE_H
#define RSysModFile__CLOSE 0x00
#define RSysModFile__GETFUNCSINFO 0x01
#define RSysModFile__GETIMPINFO 0x02
#define RSysModFile__GETINTERINFO 0x03
#define RSysModFile__GETMODULEINFO 0x04
#define RSysModFile__GETUSEDFUNC 0x05
#define RSysModFile__GETUSEDFUNCRELOC 0x06
#define RSysModFile__LOADCODE 0x07
#define RSysModFile__LOADDATA 0x08
#define RSysModFile__OPEN 0x09
typedef struct _RSysModFile_File RSysModFile_File;
typedef struct {unsigned int codeStart;unsigned int prop;} RSysModFile_FunctionInfo;
typedef struct {const char *name;} RSysModFile_ImpInfo;
typedef struct {const char *name;unsigned int nFunctions;} RSysModFile_InterInfo;
typedef struct {char md5[16];const char *comment;void *phase0Start;void *phase1Start;void *shutdown;unsigned int codeSize;unsigned int dataSize;unsigned int version;unsigned int prop;} RSysModFile_ModuleInfo;
typedef struct {const char *interface;const char *imp;unsigned int function;} RSysModFile_UsedFuncInfo;
typedef struct {const char *interface;const char *imp;unsigned int function;unsigned int offset;unsigned int prop;} RSysModFile_UsedFuncRelocInfo;
int RSysModFile_Close(RSysModFile_File*);
int RSysModFile_GetFuncsInfo(RSysModFile_File*,unsigned int,unsigned int,RSysModFile_FunctionInfo*);
int RSysModFile_GetImpInfo(RSysModFile_File*,unsigned int,unsigned int,RSysModFile_ImpInfo*);
int RSysModFile_GetInterInfo(RSysModFile_File*,unsigned int,RSysModFile_InterInfo*);
int RSysModFile_GetModuleInfo(RSysModFile_File*,RSysModFile_ModuleInfo*);
int RSysModFile_GetUsedFunc(RSysModFile_File*,unsigned int,RSysModFile_UsedFuncInfo*);
int RSysModFile_GetUsedFuncReloc(RSysModFile_File*,unsigned int,RSysModFile_UsedFuncRelocInfo*);
int RSysModFile_LoadCode(RSysModFile_File*,unsigned int,unsigned int,void*,void*,void*);
int RSysModFile_LoadData(RSysModFile_File*,unsigned int,unsigned int,void*,void*,void*);
int RSysModFile_Open(const char*,RSysModFile_File**);
#endif /* __RSYSMODFILE_H */
