/*
*****************************************
* Interface StringMan
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 11/05/2005
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2005, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__STRINGMAN_H)
#define __STRINGMAN_H
#include <stdarg.h>
#define StringMan__COMPARE 0x00
#define StringMan__CONCATENATE 0x01
#define StringMan__COPY 0x02
#define StringMan__FINDCHAR 0x03
#define StringMan__FINDLASTCHAR 0x04
#define StringMan__LENGTH 0x05
#define StringMan__NCOMPARE 0x06
#define StringMan__NCONCATENATE 0x07
#define StringMan__NCOPY 0x08
#define StringMan__NLENGTH 0x0c
#define StringMan__NPRINTF 0x0d
#define StringMan__NPRINTFARGS 0x0a
#define StringMan__PRINTF 0x09
#define StringMan__SCANF 0x0e
#define StringMan__SCANFARGS 0x0f
#define StringMan__STRTOINT 0x0b
long StringMan_Compare(const char*,const char*);
void StringMan_Concatenate(char*,const char*);
void StringMan_Copy(char*,const char*);
char *StringMan_FindChar(const char*,long);
char *StringMan_FindLastChar(const char*,long);
unsigned long StringMan_Length(const char*);
long StringMan_NCompare(const char*,const char*,unsigned long);
void StringMan_NConcatenate(char*,const char*,unsigned long);
long StringMan_NCopy(char*,const char*,unsigned long);
unsigned long StringMan_NLength(const char*,unsigned long);
long StringMan_NPrintF(char*,unsigned long,const char*,...);
long StringMan_NPrintFArgs(char*,unsigned long,const char*,va_list);
long StringMan_PrintF(char*,const char*,...);
long StringMan_ScanF(const char*,const char*,...);
long StringMan_ScanFArgs(const char*,const char*,va_list);
long StringMan_StrToInt(const char*,char**,long,long*);
#endif /* __STRINGMAN_H */
