/*
*****************************************
* Interface TaskManager_i386
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 18/03/2003
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2003, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__TASKMANAGER_I386_H)
#define __TASKMANAGER_I386_H
#define TaskManager_EAX  0
#define TaskManager_EBX  4
#define TaskManager_ECX  8
#define TaskManager_EDX 12
#define TaskManager_ESI 16
#define TaskManager_EDI 20
#define TaskManager_EBP 24
#define TaskManager_ESP 28
#define TaskManager_EIP 32
#define TaskManager_EFLAGS 36
#define TaskManager_DS 40
#define TaskManager_ES 44
#define TaskManager_SS 48
#define TaskManager_CS 52
typedef struct {unsigned int eax;unsigned int ebx;unsigned int ecx;unsigned int edx;unsigned int esi;unsigned int edi;
                unsigned int ebp;unsigned int esp;unsigned int eip;unsigned int eflags;unsigned int ds;unsigned int es;
                unsigned int ss;unsigned int cs;} TaskManager_i386_Regs;
struct _TaskManager_Regs {unsigned int eax;unsigned int ebx;unsigned int ecx;unsigned int edx;unsigned int esi;unsigned int edi;
                unsigned int ebp;unsigned int esp;unsigned int eip;unsigned int eflags;unsigned int ds;unsigned int es;
                unsigned int ss;unsigned int cs;};
#define TaskManager_INLINE_ATOMICADD __asm__ __volatile__("addl %1,%0":"=m" (*var):"ir" (value), "m" (*var));
#define TaskManager_INLINE_ATOMICDEC __asm__ __volatile__("decl %0":"=m" (*var):"m" (*var));
#define TaskManager_INLINE_ATOMICINC __asm__ __volatile__("incl %0":"=m" (*var):"m" (*var));
#define TaskManager_INLINE_ATOMICSUB __asm__ __volatile__("subl %1,%0":"=m" (*var):"ir" (value), "m" (*var));
#endif  /* __TASKMANAGER_I386_H */
