/*
*****************************************
* Interface TextVideo
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 22/06/2003
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2003, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__TEXTVIDEO_H)
#define __TEXTVIDEO_H
#define TextVideo__CLEAR 0x00
#define TextVideo__GETCURRENTMODE 0x01
#define TextVideo__GETMODEDESC 0x02
#define TextVideo__GETSTATUS 0x09
#define TextVideo__SCROLL 0x03
#define TextVideo__SETATTRIB 0x04
#define TextVideo__SETCURSORPOS 0x05
#define TextVideo__SETCURSORTYPE 0x06
#define TextVideo__SETMODE 0x07
#define TextVideo__WRITE 0x08
#define TextVideo__UCLEAR 0x0a
#define TextVideo__UGETCURRENTMODE 0x0b
#define TextVideo__UGETMODEDESC 0x0c
#define TextVideo__UGETSTATUS 0x0d
#define TextVideo__USCROLL 0x0e
#define TextVideo__USETATTRIB 0x0f
#define TextVideo__USETCURSORPOS 0x10
#define TextVideo__USETCURSORTYPE 0x11
#define TextVideo__USETMODE 0x12
#define TextVideo__UWRITE 0x13
#define TextVideo_CURSOR_DEFAULT 0x00
#define TextVideo_CURSOR_INVISIBLE 0x01
#define TextVideo_CURSOR_UNDERLINE 0x02
#define TextVideo_CURSOR_LOWER_THIRD 0x03
#define TextVideo_CURSOR_LOWER_HALF 0x04
#define TextVideo_CURSOR_TWO_THIRDS 0x05
#define TextVideo_CURSOR_BLOCK 0x06
#define TextVideo_MODE_COLOR 0x01
#define TextVideo_MODE_UNDERLINE 0x02
#define TextVideo_MODE_REVERSE 0x04
#define TextVideo_MODE_BLINK 0x08
#define TextVideo_MODE_INTENSITY 0x10
typedef struct {unsigned int rows;unsigned int cols;int flags;} TextVideo_ModeDesc;
typedef struct {unsigned int row;unsigned int col;int attrib;int cursorType;} TextVideo_Status;
void TextVideo_Clear(unsigned int,unsigned int,unsigned int,unsigned int);
unsigned int TextVideo_GetCurrentMode(void);
int TextVideo_GetModeDesc(unsigned int,TextVideo_ModeDesc*);
int TextVideo_GetStatus(TextVideo_Status*);
int TextVideo_Scroll(unsigned int,unsigned int,unsigned int,int);
void TextVideo_SetAttrib(int);
void TextVideo_SetCursorPos(unsigned int,unsigned int);
void TextVideo_SetCursorType(int);
int TextVideo_SetMode(unsigned int);
int TextVideo_Write(const char*,int);
int TextVideo_UClear(unsigned int,unsigned int,unsigned int,unsigned int);
unsigned int TextVideo_UGetCurrentMode(void);
int TextVideo_UGetModeDesc(unsigned int,TextVideo_ModeDesc*);
int TextVideo_UGetStatus(TextVideo_Status*);
int TextVideo_UScroll(unsigned int,unsigned int,unsigned int,int);
int TextVideo_USetAttrib(int);
int TextVideo_USetCursorPos(unsigned int,unsigned int);
int TextVideo_USetCursorType(int);
int TextVideo_USetMode(unsigned int);
int TextVideo_UWrite(const char*,int);
#endif  /* __TEXTVIDEO_H */
