/*
*****************************************
* Interface UserModManager
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 25/06/2005
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2005, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__USERMODMANAGER_H)
#define __USERMODMANAGER_H
#include <intermanager.h>
#define UserModManager__EXIT 0x00
#define UserModManager__REGISTER 0x01
#define UserModManager__UNREGISTER 0x02
#define UserModManager__UBRK 0x03
#define UserModManager__UCATCHEXCEPTION 0x04
#define UserModManager__UEXIT 0x05
#define UserModManager__UGETFUNCTION 0x06
#define UserModManager__UGETLIBFUNCTION 0x07
#define UserModManager__UGETSHUTDOWNFUNCTIONI 0x08
#define UserModManager__UGETSTACKSIZE 0x09
#define UserModManager__UGETSTARTFUNCTION 0x0a
#define UserModManager__UGETSTARTFUNCTIONI 0x0b
#define UserModManager__ULOAD 0x0e
#define UserModManager__UUNLOAD 0x0d
typedef struct _UserModManager_Library UserModManager_Library;
typedef struct {unsigned int code;int pid;int exitCode;unsigned int res[4];} UserModManager_ChildEvent;
typedef struct {unsigned int res[7];} UserModManager_TermEvent;
typedef struct {unsigned int type;union {UserModManager_ChildEvent child;UserModManager_TermEvent term;};} UserModManager_Events;
typedef union {InterManager_Event iEvent;UserModManager_Events uEvent;} UserModManager_Event;
#define UserModManager_EVENT_CHILD 0x10
#define UserModManager_EVENT_TERM 0x11
#define UserModManager_CHILD_EXITED 0x00
#define UserModManager_CHILD_KILLED 0x01
#define UserModManager_CHILD_DUMPED 0x02
#define UserModManager_CHILD_STOPED 0x03
#define UserModManager_CHILD_CONTINUED 0x04
#define UserModManager_CHILD_DUMPED_MEMREF 0x00
#define UserModManager_CHILD_DUMPED_BADMEM 0x01
#define UserModManager_CHILD_DUMPED_ILINST 0x02
#define UserModManager_CHILD_DUMPED_FPE 0x03
#define UserModManager_CHILD_DUMPED_DIV0 0x04
#define UserModManager_CHILD_DUMPED_INTO 0x05
#define UserModManager_CHILD_DUMPED_BOUND 0x06
#define UserModManager_LIB_FUNCTION 0x00
#define UserModManager_SYS_FUNCTION 0x01
#define UserModManager_PERMANENT 0x01
#include <taskmanager.h>
int UserModManager_Exit(TaskManager_Task*,int);
int UserModManager_Register(const char*,int);
int UserModManager_Unregister(const char*,int);
int UserModManager_UCatchException(void*);
void UserModManager_UExit(int);
void *UserModManager_UGetFunction(const char*,const char*,unsigned int,int);
void *UserModManager_UGetLibFunction(UserModManager_Library*,const char*,const char*,unsigned int);
void *UserModManager_UGetShutdownFunctionI(unsigned int);
unsigned int UserModManager_UGetStackSize(void);
void *UserModManager_UGetStartFunction(void*);
void *UserModManager_UGetStartFunctionI(unsigned int);
int UserModManager_ULoad(const char*,UserModManager_Library**);
int UserModManager_UUnload(UserModManager_Library*);
#endif /* __USERMODMANAGER_H */
