/*
*****************************************
* Interface UserSpaceManager
*
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 08/06/2003
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2003, Luiz Henrique Shigunov
*****************************************
*/

#if !defined(__USERSPACEMANAGER_H)
#define __USERSPACEMANAGER_H
#define UserSpaceManager__COPYFROMUSER 0x00
#define UserSpaceManager__COPYTOUSER 0x01
#define UserSpaceManager__EXIT 0x02
#define UserSpaceManager__MAPSTACKPAGES 0x03
#define UserSpaceManager__REGISTERLOADER 0x04
#define UserSpaceManager__RUN 0x05
#define UserSpaceManager__STRLEN 0x06
#define UserSpaceManager__STRNCOPY 0x07
#define UserSpaceManager__UNREGISTERLOADER 0x08
#define UserSpaceManager__URUN 0x09
typedef struct {unsigned int exitType;unsigned int exitCode;} UserSpaceManager_ExitInfo;
#include <fsmanager.h>
typedef struct {FSManager_Handle *fd;char fileBuf[128];unsigned int stackTop,argc,envc,exec,stackSize,startBrk;} UserSpaceManager_ExecInfo;
#define UserSpaceManager_RUN_USER 0x01
#define UserSpaceManager_RUN_SUSPENDED 0x02
#define UserSpaceManager_PERMANENT 0x01
#define UserSpaceManager_TASK_EXITED 0x00
#define UserSpaceManager_TASK_KILLED 0x01
#define UserSpaceManager_TASK_DUMPED 0x02
#define UserSpaceManager_TASK_DUMPED_MEMREF 0x00
#define UserSpaceManager_TASK_DUMPED_BADMEM 0x01
#define UserSpaceManager_TASK_DUMPED_ILINST 0x02
#define UserSpaceManager_TASK_DUMPED_FPE 0x03
#define UserSpaceManager_TASK_DUMPED_DIV0 0x04
#define UserSpaceManager_TASK_DUMPED_INTO 0x05
#define UserSpaceManager_TASK_DUMPED_BOUND 0x06
#include <taskmanager.h>
void *UserSpaceManager_Brk(void*);
int UserSpaceManager_CopyFromUser(void*,const void*,unsigned int);
int UserSpaceManager_CopyToUser(void*,const void*,unsigned int);
int UserSpaceManager_Exit(TaskManager_Task*,unsigned int,unsigned int);
int UserSpaceManager_MapStackPages(UserSpaceManager_ExecInfo*,char*,unsigned int);
int UserSpaceManager_RegisterLoader(const char*,int);
int UserSpaceManager_Run(const char*,char*const*,char*const*,int,TaskManager_Task**,TaskManager_Thread**);
int UserSpaceManager_StrLen(const char*,unsigned int*);
int UserSpaceManager_StrNCopy(char*,const char*,unsigned int,unsigned int*);
int UserSpaceManager_UnregisterLoader(const char*,int);
void *UserSpaceManager_UBrk(void*);
int UserSpaceManager_URun(const char*,char*const*,char*const*);
#endif /* __USERSPACEMANAGER_H */
