/*
*****************************************
* This file implements the Exception interface
*
* Version: 0.1.3
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 01/07/2005
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2005, Luiz Henrique Shigunov
*
* This module is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This module is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this module; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************
*/

#include <stddef.h>
#include "errormanager.h"
#include "lib/exception.h"
#include "usermodmanager.h"

void (*callBack)(User_Exception_Exception *);

void ExceptionHandler(void);

#ifdef _INCLUDE_ASM
void ExceptionHandler(void) {
    /* save all registers */
    if (!callBack)
        UserModManager_UExit(1);
    callBack((User_Exception_Exception*)0x1234);
    /* restore all registers */
    /* remove exception arguments */
    /* setup the stack to return */
}
#endif

void SetCallBack(void *aCallBack) {
    callBack = aCallBack;
}

int Start(void) {
    if (UserModManager_UCatchException(ExceptionHandler))
        return E_UNDEFINED;
    return E_OK;
}
