/*
*****************************************
* This file implements the Semaphore interface
*
* Version: 0.1
* Author: Luiz Henrique Shigunov
* E-mail: luizshigunov@users.sourceforge.net
* WEB: http://www.sourceforge.net/projects/modulos
* Last change: 05/02/2002
*
* See the interface specification to know what each function does.
*
* Copyright (C) 2000-2002, Luiz Henrique Shigunov
*
* This module is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This module is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this module; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*****************************************
*/

/* THIS IMPLEMENTATION IS FOR A 386 OR BETTER. WITH A 486 OR BETTER WE HAVE OTHER OPTIONS.
   WITH A 486 OR BETTER WE DON'T NEED TO DO A SYSCALL IF THE SEMAPHORE COUNT IS > 0. */

#include <stddef.h>
#include "errormanager.h"
#include "taskmanager.h"

typedef struct {
    TaskManager_Semaphore s;
    unsigned int data[2];
} Semaphore;

int Destroy(Semaphore *s) {
    if (s->s.count)
        return E_BUSY;
    return E_OK;
}

int Init(Semaphore *s, int value, int prop) {
    s->s.count = value;
    s->s.data = NULL;
    return E_OK;
}

int P(Semaphore *s) {
    return TaskManager_UP((TaskManager_Semaphore*)s);
}

int TryP(Semaphore *s) {
    return TaskManager_UTryP((TaskManager_Semaphore*)s);
}

int V(Semaphore *s) {
    return TaskManager_UV((TaskManager_Semaphore*)s);
}
